package ru.ulstu.fc.rule.service;

import org.springframework.stereotype.Service;

import ru.ulstu.fc.project.repository.RuleRepository;
import ru.ulstu.fc.project.service.ProjectService;
import ru.ulstu.fc.rule.model.Rule;
import ru.ulstu.fc.rule.model.RuleForm;

@Service
public class RuleService {
    private final RuleRepository ruleRepository;
    private final ProjectService projectService;

    public RuleService(RuleRepository ruleRepository, ProjectService projectService) {
        this.ruleRepository = ruleRepository;
        this.projectService = projectService;
    }

    public Rule getById(Integer id) {
        return ruleRepository
                .findById(id)
                .orElseThrow(() -> new RuntimeException("Rule not found by id"));
    }

    public Object save(RuleForm ruleForm) {
        if (ruleForm.getId() == null) {
            Rule rule = new Rule();
            rule.setProject(projectService.getById(ruleForm.getProjectId()));
            // rule.set...
            return ruleRepository.save(rule);
        }
        Rule dbRule = getById(ruleForm.getId());
        dbRule.setProject(projectService.getById(ruleForm.getProjectId()));
        // dbRule.set ...
        return ruleRepository.save(dbRule);
    }

    public void delete(RuleForm ruleForm) {
        getById(ruleForm.getId());
        ruleRepository.deleteById(ruleForm.getId());
    }
}
